Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/ProductEditor.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/ProductEditor.Designer.cs	(revision 3546)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/ProductEditor.Designer.cs	(revision 3547)
@@ -48,5 +48,4 @@
       this.refreshButton = new System.Windows.Forms.Button();
       this.uploadButton = new System.Windows.Forms.Button();
-      this.newProductButton = new System.Windows.Forms.Button();
       this.splitContainer = new System.Windows.Forms.SplitContainer();
       this.productsGroupBox = new System.Windows.Forms.GroupBox();
@@ -57,5 +56,4 @@
       this.detailsGroupBox = new System.Windows.Forms.GroupBox();
       this.pluginsGroupBox = new System.Windows.Forms.GroupBox();
-      this.pluginListView = new HeuristicLab.PluginInfrastructure.Advanced.PluginListView();
       this.versionTextBox = new System.Windows.Forms.TextBox();
       this.nameLabel = new System.Windows.Forms.Label();
@@ -63,5 +61,7 @@
       this.versionLabel = new System.Windows.Forms.Label();
       this.pluginImageList = new System.Windows.Forms.ImageList(this.components);
+      this.newProductButton = new System.Windows.Forms.Button();
       this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      this.pluginListView = new HeuristicLab.PluginInfrastructure.Advanced.PluginListView();
       this.splitContainer.Panel1.SuspendLayout();
       this.splitContainer.Panel2.SuspendLayout();
@@ -75,9 +75,12 @@
       // refreshButton
       // 
-      this.refreshButton.Location = new System.Drawing.Point(6, 19);
+      this.refreshButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.refreshButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.VS2008ImageLibrary_Objects_Internet;
+      this.refreshButton.Location = new System.Drawing.Point(6, 389);
       this.refreshButton.Name = "refreshButton";
-      this.refreshButton.Size = new System.Drawing.Size(75, 23);
+      this.refreshButton.Size = new System.Drawing.Size(73, 31);
       this.refreshButton.TabIndex = 1;
       this.refreshButton.Text = "Refresh";
+      this.refreshButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
       this.refreshButton.UseVisualStyleBackColor = true;
       this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
@@ -87,22 +90,13 @@
       this.uploadButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.uploadButton.Enabled = false;
-      this.uploadButton.Location = new System.Drawing.Point(6, 397);
+      this.uploadButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.VS2008ImageLibrary_CommonElements_Objects_Arrow_Up;
+      this.uploadButton.Location = new System.Drawing.Point(85, 389);
       this.uploadButton.Name = "uploadButton";
-      this.uploadButton.Size = new System.Drawing.Size(96, 23);
+      this.uploadButton.Size = new System.Drawing.Size(120, 31);
       this.uploadButton.TabIndex = 2;
       this.uploadButton.Text = "Upload Products";
+      this.uploadButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
       this.uploadButton.UseVisualStyleBackColor = true;
       this.uploadButton.Click += new System.EventHandler(this.saveButton_Click);
-      // 
-      // newProductButton
-      // 
-      this.newProductButton.Enabled = false;
-      this.newProductButton.Location = new System.Drawing.Point(87, 19);
-      this.newProductButton.Name = "newProductButton";
-      this.newProductButton.Size = new System.Drawing.Size(91, 23);
-      this.newProductButton.TabIndex = 3;
-      this.newProductButton.Text = "New product";
-      this.newProductButton.UseVisualStyleBackColor = true;
-      this.newProductButton.Click += new System.EventHandler(this.newProductButton_Click);
       // 
       // splitContainer
@@ -125,9 +119,11 @@
       // productsGroupBox
       // 
+      this.productsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.productsGroupBox.Controls.Add(this.uploadButton);
       this.productsGroupBox.Controls.Add(this.newProductButton);
       this.productsGroupBox.Controls.Add(this.productsListView);
       this.productsGroupBox.Controls.Add(this.refreshButton);
-      this.productsGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
       this.productsGroupBox.Location = new System.Drawing.Point(0, 0);
       this.productsGroupBox.Name = "productsGroupBox";
@@ -147,8 +143,8 @@
       this.productsListView.Enabled = false;
       this.productsListView.FullRowSelect = true;
-      this.productsListView.Location = new System.Drawing.Point(6, 48);
+      this.productsListView.Location = new System.Drawing.Point(6, 56);
       this.productsListView.MultiSelect = false;
       this.productsListView.Name = "productsListView";
-      this.productsListView.Size = new System.Drawing.Size(309, 343);
+      this.productsListView.Size = new System.Drawing.Size(309, 327);
       this.productsListView.SmallImageList = this.productImageList;
       this.productsListView.TabIndex = 4;
@@ -175,4 +171,7 @@
       // detailsGroupBox
       // 
+      this.detailsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.detailsGroupBox.Controls.Add(this.pluginsGroupBox);
       this.detailsGroupBox.Controls.Add(this.versionTextBox);
@@ -180,5 +179,4 @@
       this.detailsGroupBox.Controls.Add(this.nameTextBox);
       this.detailsGroupBox.Controls.Add(this.versionLabel);
-      this.detailsGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
       this.detailsGroupBox.Location = new System.Drawing.Point(0, 0);
       this.detailsGroupBox.Name = "detailsGroupBox";
@@ -201,7 +199,74 @@
       this.pluginsGroupBox.Text = "Plugins";
       // 
+      // versionTextBox
+      // 
+      this.versionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.versionTextBox.Enabled = false;
+      this.versionTextBox.Location = new System.Drawing.Point(57, 45);
+      this.versionTextBox.Name = "versionTextBox";
+      this.versionTextBox.Size = new System.Drawing.Size(277, 20);
+      this.versionTextBox.TabIndex = 5;
+      this.versionTextBox.TextChanged += new System.EventHandler(this.versionTextBox_TextChanged);
+      // 
+      // nameLabel
+      // 
+      this.nameLabel.AutoSize = true;
+      this.nameLabel.Enabled = false;
+      this.nameLabel.Location = new System.Drawing.Point(13, 22);
+      this.nameLabel.Name = "nameLabel";
+      this.nameLabel.Size = new System.Drawing.Size(38, 13);
+      this.nameLabel.TabIndex = 2;
+      this.nameLabel.Text = "Name:";
+      // 
+      // nameTextBox
+      // 
+      this.nameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.nameTextBox.Enabled = false;
+      this.nameTextBox.Location = new System.Drawing.Point(57, 19);
+      this.nameTextBox.Name = "nameTextBox";
+      this.nameTextBox.Size = new System.Drawing.Size(277, 20);
+      this.nameTextBox.TabIndex = 3;
+      this.nameTextBox.TextChanged += new System.EventHandler(this.nameTextBox_TextChanged);
+      // 
+      // versionLabel
+      // 
+      this.versionLabel.AutoSize = true;
+      this.versionLabel.Enabled = false;
+      this.versionLabel.Location = new System.Drawing.Point(6, 48);
+      this.versionLabel.Name = "versionLabel";
+      this.versionLabel.Size = new System.Drawing.Size(45, 13);
+      this.versionLabel.TabIndex = 4;
+      this.versionLabel.Text = "Version:";
+      // 
+      // pluginImageList
+      // 
+      this.pluginImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
+      this.pluginImageList.ImageSize = new System.Drawing.Size(16, 16);
+      this.pluginImageList.TransparentColor = System.Drawing.Color.Transparent;
+      // 
+      // newProductButton
+      // 
+      this.newProductButton.Enabled = false;
+      this.newProductButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.VS2008ImageLibrary_CommonElements_Actions_Add;
+      this.newProductButton.Location = new System.Drawing.Point(6, 19);
+      this.newProductButton.Name = "newProductButton";
+      this.newProductButton.Size = new System.Drawing.Size(104, 31);
+      this.newProductButton.TabIndex = 3;
+      this.newProductButton.Text = "Create Product";
+      this.newProductButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
+      this.newProductButton.UseVisualStyleBackColor = true;
+      this.newProductButton.Click += new System.EventHandler(this.newProductButton_Click);
+      // 
+      // errorProvider
+      // 
+      this.errorProvider.ContainerControl = this;
+      // 
       // pluginListView
       // 
-      this.pluginListView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.pluginListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.pluginListView.Enabled = false;
       this.pluginListView.Location = new System.Drawing.Point(3, 16);
@@ -211,56 +276,4 @@
       this.pluginListView.TabIndex = 7;
       this.pluginListView.ItemChecked += new System.Windows.Forms.ItemCheckedEventHandler(this.pluginListView_ItemChecked);
-      // 
-      // versionTextBox
-      // 
-      this.versionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.versionTextBox.Enabled = false;
-      this.versionTextBox.Location = new System.Drawing.Point(57, 45);
-      this.versionTextBox.Name = "versionTextBox";
-      this.versionTextBox.Size = new System.Drawing.Size(277, 20);
-      this.versionTextBox.TabIndex = 5;
-      this.versionTextBox.TextChanged += new System.EventHandler(this.versionTextBox_TextChanged);
-      // 
-      // nameLabel
-      // 
-      this.nameLabel.AutoSize = true;
-      this.nameLabel.Enabled = false;
-      this.nameLabel.Location = new System.Drawing.Point(13, 22);
-      this.nameLabel.Name = "nameLabel";
-      this.nameLabel.Size = new System.Drawing.Size(38, 13);
-      this.nameLabel.TabIndex = 2;
-      this.nameLabel.Text = "Name:";
-      // 
-      // nameTextBox
-      // 
-      this.nameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.nameTextBox.Enabled = false;
-      this.nameTextBox.Location = new System.Drawing.Point(57, 19);
-      this.nameTextBox.Name = "nameTextBox";
-      this.nameTextBox.Size = new System.Drawing.Size(277, 20);
-      this.nameTextBox.TabIndex = 3;
-      this.nameTextBox.TextChanged += new System.EventHandler(this.nameTextBox_TextChanged);
-      // 
-      // versionLabel
-      // 
-      this.versionLabel.AutoSize = true;
-      this.versionLabel.Enabled = false;
-      this.versionLabel.Location = new System.Drawing.Point(6, 48);
-      this.versionLabel.Name = "versionLabel";
-      this.versionLabel.Size = new System.Drawing.Size(45, 13);
-      this.versionLabel.TabIndex = 4;
-      this.versionLabel.Text = "Version:";
-      // 
-      // pluginImageList
-      // 
-      this.pluginImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
-      this.pluginImageList.ImageSize = new System.Drawing.Size(16, 16);
-      this.pluginImageList.TransparentColor = System.Drawing.Color.Transparent;
-      // 
-      // errorProvider
-      // 
-      this.errorProvider.ContainerControl = this;
       // 
       // ProductEditor
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/ProductEditor.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/ProductEditor.cs	(revision 3546)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/ProductEditor.cs	(revision 3547)
@@ -60,17 +60,17 @@
       var products = (IEnumerable<DeploymentService.ProductDescription>)e.Argument;
       var adminClient = DeploymentService.AdminClientFactory.CreateClient();
-      try {
-        foreach (var product in products) {
-          adminClient.DeployProduct(product);
-        }
-        e.Cancel = false;
-      }
-      catch (FaultException) {
+      foreach (var product in products) {
+        adminClient.DeployProduct(product);
       }
     }
 
     private void uploadChangedProductsWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
-      this.Enabled = true;
-      refreshProductsWorker.RunWorkerAsync();
+      if (e.Error != null) {
+        MessageBox.Show("There was an error while connecting to the server." + Environment.NewLine +
+           "Please check your connection settings and user credentials.");
+      } else {
+        this.Enabled = true;
+        refreshProductsWorker.RunWorkerAsync();
+      }
     }
     #endregion
@@ -79,14 +79,12 @@
     private void refreshProductsWorker_DoWork(object sender, DoWorkEventArgs e) {
       var updateClient = DeploymentService.UpdateClientFactory.CreateClient();
-      try {
-        e.Result = new object[] { updateClient.GetProducts(), updateClient.GetPlugins() };
-      }
-      catch (FaultException) {
-        e.Cancel = true;
-      }
+      e.Result = new object[] { updateClient.GetProducts(), updateClient.GetPlugins() };
     }
 
     private void refreshProductsWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
-      if (!e.Cancelled && e.Result != null) {
+      if (e.Error != null) {
+        MessageBox.Show("There was an error while connecting to the server." + Environment.NewLine +
+                   "Please check your connection settings and user credentials.");
+      } else {
         this.products = new List<DeploymentService.ProductDescription>(
           (DeploymentService.ProductDescription[])((object[])e.Result)[0]);
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.Designer.cs	(revision 3546)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.Designer.cs	(revision 3547)
@@ -51,4 +51,6 @@
       this.versionHeader = new System.Windows.Forms.ColumnHeader();
       this.descriptionHeader = new System.Windows.Forms.ColumnHeader();
+      this.refreshButton = new System.Windows.Forms.Button();
+      this.installButton = new System.Windows.Forms.Button();
       this.SuspendLayout();
       // 
@@ -75,5 +77,5 @@
       this.remotePluginsListView.Location = new System.Drawing.Point(0, 0);
       this.remotePluginsListView.Name = "remotePluginsListView";
-      this.remotePluginsListView.Size = new System.Drawing.Size(533, 558);
+      this.remotePluginsListView.Size = new System.Drawing.Size(533, 527);
       this.remotePluginsListView.SuppressItemCheckedEvents = false;
       this.remotePluginsListView.TabIndex = 0;
@@ -97,8 +99,37 @@
       this.descriptionHeader.Width = 250;
       // 
+      // refreshButton
+      // 
+      this.refreshButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.refreshButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.VS2008ImageLibrary_Objects_Internet;
+      this.refreshButton.Location = new System.Drawing.Point(0, 533);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(72, 25);
+      this.refreshButton.TabIndex = 16;
+      this.refreshButton.Text = "Refresh";
+      this.refreshButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshRemoteButton_Click);
+      // 
+      // installButton
+      // 
+      this.installButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.installButton.Enabled = false;
+      this.installButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.VS2008ImageLibrary_Objects_Install;
+      this.installButton.Location = new System.Drawing.Point(78, 533);
+      this.installButton.Name = "installButton";
+      this.installButton.Size = new System.Drawing.Size(140, 25);
+      this.installButton.TabIndex = 17;
+      this.installButton.Text = "Install Selected Items";
+      this.installButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageBeforeText;
+      this.installButton.UseVisualStyleBackColor = true;
+      this.installButton.Click += new System.EventHandler(this.installButton_Click);
+      // 
       // RemotePluginInstallerView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.refreshButton);
+      this.Controls.Add(this.installButton);
       this.Controls.Add(this.remotePluginsListView);
       this.Name = "RemotePluginInstallerView";
@@ -114,4 +145,6 @@
     private System.Windows.Forms.ColumnHeader versionHeader;
     private System.Windows.Forms.ColumnHeader descriptionHeader;
+    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.Button installButton;
   }
 }
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.cs	(revision 3546)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.cs	(revision 3547)
@@ -27,8 +27,19 @@
 using System.Text;
 using System.Windows.Forms;
+using HeuristicLab.PluginInfrastructure.Manager;
 
 namespace HeuristicLab.PluginInfrastructure.Advanced {
-  internal partial class RemotePluginInstallerView : UserControl {
-    public event ItemCheckedEventHandler ItemChecked;
+  internal partial class RemotePluginInstallerView : InstallationManagerControl {
+    private class RefreshBackgroundWorkerResult {
+      public IEnumerable<IPluginDescription> RemotePlugins { get; set; }
+      public IEnumerable<DeploymentService.ProductDescription> RemoteProducts { get; set; }
+    }
+    private class UpdateOrInstallPluginsBackgroundWorkerArgument {
+      public IEnumerable<IPluginDescription> PluginsToUpdate { get; set; }
+      public IEnumerable<IPluginDescription> PluginsToInstall { get; set; }
+    }
+    private const string PluginDiscoveryMessage = "Looking for new plugins...";
+    private BackgroundWorker refreshServerPluginsBackgroundWorker;
+    private BackgroundWorker updateOrInstallPluginsBackgroundWorker;
 
     private ListViewGroup newPluginsGroup;
@@ -47,12 +58,4 @@
     }
 
-    public RemotePluginInstallerView() {
-      InitializeComponent();
-
-      newPluginsGroup = remotePluginsListView.Groups["newPluginsGroup"];
-      productsGroup = remotePluginsListView.Groups["productsGroup"];
-      allPluginsGroup = remotePluginsListView.Groups["allPluginsGroup"];
-    }
-
     private IEnumerable<DeploymentService.ProductDescription> products;
     public IEnumerable<DeploymentService.ProductDescription> Products {
@@ -97,4 +100,110 @@
       }
     }
+
+    private InstallationManager installationManager;
+    public InstallationManager InstallationManager {
+      get { return installationManager; }
+      set { installationManager = value; }
+    }
+    private PluginManager pluginManager;
+    public PluginManager PluginManager {
+      get { return pluginManager; }
+      set { pluginManager = value; }
+    }
+    public RemotePluginInstallerView() {
+      InitializeComponent();
+
+      refreshServerPluginsBackgroundWorker = new BackgroundWorker();
+      refreshServerPluginsBackgroundWorker.DoWork += new DoWorkEventHandler(refreshServerPluginsBackgroundWorker_DoWork);
+      refreshServerPluginsBackgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(refreshServerPluginsBackgroundWorker_RunWorkerCompleted);
+
+      updateOrInstallPluginsBackgroundWorker = new BackgroundWorker();
+      updateOrInstallPluginsBackgroundWorker.DoWork += new DoWorkEventHandler(updateOrInstallPluginsBackgroundWorker_DoWork);
+      updateOrInstallPluginsBackgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(updateOrInstallPluginsBackgroundWorker_RunWorkerCompleted);
+
+      newPluginsGroup = remotePluginsListView.Groups["newPluginsGroup"];
+      productsGroup = remotePluginsListView.Groups["productsGroup"];
+      allPluginsGroup = remotePluginsListView.Groups["allPluginsGroup"];
+    }
+
+
+    #region event handlers for refresh server plugins background worker
+    void refreshServerPluginsBackgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
+      if (e.Error != null) {
+        StatusView.ShowError("Connection Error",
+          "There was an error while connecting to the server." + Environment.NewLine +
+          "Please check your connection settings and user credentials.");
+      } else {
+        RefreshBackgroundWorkerResult refreshResult = (RefreshBackgroundWorkerResult)e.Result;
+        UpdateRemotePluginList(refreshResult.RemoteProducts, refreshResult.RemotePlugins);
+      }
+      StatusView.UnlockUI();
+      StatusView.RemoveMessage(PluginDiscoveryMessage);
+      StatusView.HideProgressIndicator();
+    }
+
+    void refreshServerPluginsBackgroundWorker_DoWork(object sender, DoWorkEventArgs e) {
+      RefreshBackgroundWorkerResult result = new RefreshBackgroundWorkerResult();
+      result.RemotePlugins = installationManager.GetRemotePluginList();
+      result.RemoteProducts = installationManager.GetRemoteProductList();
+      e.Result = result;
+    }
+    #endregion
+    #region event handlers for plugin update background worker
+    void updateOrInstallPluginsBackgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
+      if (e.Error != null) {
+        StatusView.ShowError("Connection Error",
+          "There was an error while connecting to the server." + Environment.NewLine +
+          "Please check your connection settings and user credentials.");
+      } else {
+        UpdateControl();
+      }
+      StatusView.UnlockUI();
+      StatusView.HideProgressIndicator();
+    }
+
+    void updateOrInstallPluginsBackgroundWorker_DoWork(object sender, DoWorkEventArgs e) {
+      UpdateOrInstallPluginsBackgroundWorkerArgument info = (UpdateOrInstallPluginsBackgroundWorkerArgument)e.Argument;
+      if (info.PluginsToInstall.Count() > 0)
+        installationManager.Install(info.PluginsToInstall);
+      if (info.PluginsToUpdate.Count() > 0)
+        installationManager.Update(info.PluginsToUpdate);
+
+      if (info.PluginsToInstall.Count() > 0 || info.PluginsToUpdate.Count() > 0)
+        pluginManager.DiscoverAndCheckPlugins();
+    }
+    #endregion
+
+
+    #region button events
+    private void refreshRemoteButton_Click(object sender, EventArgs e) {
+      StatusView.LockUI();
+      StatusView.ShowProgressIndicator();
+      StatusView.ShowMessage(PluginDiscoveryMessage);
+      refreshServerPluginsBackgroundWorker.RunWorkerAsync();
+    }
+    private void installButton_Click(object sender, EventArgs e) {
+      StatusView.LockUI();
+      StatusView.ShowProgressIndicator();
+      var updateOrInstallInfo = new UpdateOrInstallPluginsBackgroundWorkerArgument();
+      // if there is a local plugin with same name and same major and minor version then it's an update
+      var pluginsToUpdate = from remotePlugin in CheckedPlugins
+                            let matchingLocalPlugins = from localPlugin in pluginManager.Plugins
+                                                       where localPlugin.Name == remotePlugin.Name
+                                                       where localPlugin.Version.Major == remotePlugin.Version.Major
+                                                       where localPlugin.Version.Minor == remotePlugin.Version.Minor
+                                                       where IsNewerThan(remotePlugin, localPlugin)
+                                                       select localPlugin
+                            where matchingLocalPlugins.Count() > 0
+                            select remotePlugin;
+
+      // otherwise install a new plugin
+      var pluginsToInstall = CheckedPlugins.Except(pluginsToUpdate);
+
+      updateOrInstallInfo.PluginsToInstall = pluginsToInstall;
+      updateOrInstallInfo.PluginsToUpdate = pluginsToUpdate;
+      updateOrInstallPluginsBackgroundWorker.RunWorkerAsync(updateOrInstallInfo);
+    }
+    #endregion
 
     private void UpdateControl() {
@@ -159,5 +268,5 @@
         }
       }
-      OnItemChecked(e);
+      installButton.Enabled = remotePluginsListView.CheckedItems.Count > 0;
     }
 
@@ -238,7 +347,4 @@
     }
 
-    private void OnItemChecked(ItemCheckedEventArgs e) {
-      if (ItemChecked != null) ItemChecked(this, e);
-    }
     #endregion
 
@@ -258,5 +364,32 @@
     }
 
-    #endregion
+    private void UpdateRemotePluginList(
+      IEnumerable<DeploymentService.ProductDescription> remoteProducts,
+      IEnumerable<IPluginDescription> remotePlugins) {
+
+      var mostRecentRemotePlugins = from remote in remotePlugins
+                                    where !remotePlugins.Any(x => x.Name == remote.Name && x.Version > remote.Version) // same name and higher version
+                                    select remote;
+
+      var newPlugins = from remote in mostRecentRemotePlugins
+                       let matchingLocal = (from local in pluginManager.Plugins
+                                            where local.Name == remote.Name
+                                            where local.Version < remote.Version
+                                            select local).FirstOrDefault()
+                       where matchingLocal != null
+                       select remote;
+
+      NewPlugins = newPlugins;
+      Products = remoteProducts;
+      AllPlugins = remotePlugins;
+    }
+    private bool IsNewerThan(IPluginDescription plugin1, IPluginDescription plugin2) {
+      // newer: build version is higher, or if build version is the same revision is higher
+      if (plugin1.Version.Build < plugin2.Version.Build) return false;
+      else if (plugin1.Version.Build > plugin2.Version.Build) return true;
+      else return plugin1.Version.Revision > plugin2.Version.Revision;
+    }
+    #endregion
+
 
   }
